GNU bug report logs - #56739
29.0.50; `cl-psetq' and `cl-psetf' fail to recognize symbol macros

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Wing Hei Chan <whmunkchan@HIDDEN>; Keywords: patch; dated Sun, 24 Jul 2022 12:34:03 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 56739 <at> debbugs.gnu.org:


Received: (at 56739) by debbugs.gnu.org; 5 Sep 2022 19:14:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Sep 05 15:14:48 2022
Received: from localhost ([127.0.0.1]:48904 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oVHYW-0001dx-Jj
	for submit <at> debbugs.gnu.org; Mon, 05 Sep 2022 15:14:48 -0400
Received: from quimby.gnus.org ([95.216.78.240]:43182)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1oVHYU-0001dl-N5
 for 56739 <at> debbugs.gnu.org; Mon, 05 Sep 2022 15:14:47 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:Date:References:
 In-Reply-To:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=lzFicOJAb2gZs0TfCGflOFX8YlrRLyPxqjVpimtmBl4=; b=sKMkttD7Enu9pBVbminhJCAy8y
 pBupyXIaJGYdWfQ1qmg74VqF4JXmGsgGuv5oRVWvNpR/oalsMm1Q+YaNN92Uxs85ic1+qifIb1Dwp
 0tDzwxAPG98lgr3P4RJwW5nydRux/tQtX8urzsXAyN4VFyvEJncjtsi/olT/bTNPh4SU=;
Received: from [84.212.220.105] (helo=joga)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1oVHYL-0004Z5-Bj; Mon, 05 Sep 2022 21:14:39 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#56739: 29.0.50; `cl-psetq' and `cl-psetf' fail to recognize
 symbol macros
In-Reply-To: <87y1w6xjmg.fsf@HIDDEN> (Michael Heerdegen's message of "Wed, 03
 Aug 2022 02:20:55 +0200")
References: <OSZP286MB1260387EB0097C4D07840B54DA929@HIDDEN>
 <8735eeyz7e.fsf@HIDDEN> <87y1w6xjmg.fsf@HIDDEN>
X-Now-Playing: The Rolling Stones's _Black and Blue_: "Crazy Mama"
Date: Mon, 05 Sep 2022 21:14:35 +0200
Message-ID: <87zgfdzl9g.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Michael Heerdegen <michael_heerdegen@HIDDEN> writes: > I
 think
 we can fix this (both cases mentioned) similarly as in cl-letf: > > From
 29ea21a751ab6e71b2fb34c781131e31fc7b950d Mon Sep 17 00:00:00 2001 > From:
 Michael Heerdegen <michael_heerdegen@HIDDEN [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 56739
Cc: 56739 <at> debbugs.gnu.org, Wing Hei Chan <whmunkchan@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> I think we can fix this (both cases mentioned) similarly as in cl-letf:
>
> From 29ea21a751ab6e71b2fb34c781131e31fc7b950d Mon Sep 17 00:00:00 2001
> From: Michael Heerdegen <michael_heerdegen@HIDDEN>
> Date: Wed, 3 Aug 2022 02:06:16 +0200
> Subject: [PATCH] WIP: Fix symbol macros used in cl-psetf (Bug#56739)

This was a month ago, but as far as I can tell, this patch was never
pushed.

Perhaps Stefan has some comments here; added to the CCs.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#56739; Package emacs. Full text available.
Added tag(s) patch. Request was from Stefan Kangas <stefan@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 56739 <at> debbugs.gnu.org:


Received: (at 56739) by debbugs.gnu.org; 3 Aug 2022 00:21:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Aug 02 20:21:11 2022
Received: from localhost ([127.0.0.1]:45530 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oJ28N-00016G-Kq
	for submit <at> debbugs.gnu.org; Tue, 02 Aug 2022 20:21:11 -0400
Received: from mout.web.de ([212.227.15.14]:44631)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1oJ28H-00015M-Md
 for 56739 <at> debbugs.gnu.org; Tue, 02 Aug 2022 20:21:10 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1659486056;
 bh=aezxof+s/wJbi8nzTBQjcU2EOJdvtqSmKxzlq+RsIzc=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=E6lNSTWkCbXabCjpreEuZpFv5dqajPrQktZ+6rC0SvGC/57W9gv2X2eXfrjTjnOHx
 gZ3hiMa5Kj5nNw/WvJk8KEtmJDxMcZvBFPA4Ktc/raRvUs0ndLKIjycBsJmi8MwM9y
 fS70z21a2v2BYebKO6sAlV8uP0m02CT7wbrdPRok=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.57.248.18]) by smtp.web.de (mrweb006
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MGQC9-1oDC2H0xYL-00GfSx; Wed, 03
 Aug 2022 02:20:56 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Wing Hei Chan <whmunkchan@HIDDEN>
Subject: Re: bug#56739: 29.0.50; `cl-psetq' and `cl-psetf' fail to recognize
 symbol macros
In-Reply-To: <8735eeyz7e.fsf@HIDDEN> (Michael Heerdegen's message of "Wed, 03
 Aug 2022 01:59:01 +0200")
References: <OSZP286MB1260387EB0097C4D07840B54DA929@HIDDEN>
 <8735eeyz7e.fsf@HIDDEN>
Date: Wed, 03 Aug 2022 02:20:55 +0200
Message-ID: <87y1w6xjmg.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Provags-ID: V03:K1:NMcqkymw3rA7QjOE3ny6oWJtmgA+iMwadkxh/pbeyl8rsCe4mxA
 LBMTAKFlqbnFr64t22p6/stfXafuk1yMpXS+esI+QodeeuVJvGMRVLS74asWgFM8ZEhZ4ib
 TAn4Zm8YkGT+RLtgj03F7pPw7qzXOq/Ivw0A9hMxX2v1kTdbmIKmvkMP8v5/TpNWiPq51Dn
 9ty9VmXNVb5mb8UQdxXFg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:4jVbzibFpiE=:jCQH7qVtC8bHM+0vYIbNWJ
 2Inhfe7boNca6MDsdHRgaGwOQPgk2Jq0FFMKl1MOdw8Iv6SRU/wxrwjXaHm3wpDbKtK7wtMUv
 /aBcVguCbxNn/xeOlR3nGQR36lQCBVl8dmUmzpNMLw/zq5XwUJELlLiBuDFEu3EMptRLx7R3v
 CK8hv/92Knxocyyl6KcSPHP2eiz4BO0NZb2IIY+a/QMDKAi942C2gOC6rZxk3rIKSm3wzcQVC
 7ivQjRfkCpUh0suSGL2bprWCJpOQUm6lISNq1JnN/u9dCPiHukPP3U0gCEuzpHi537h7PVUO1
 7rcBQy4Bhzy0Yxu7HIT5KSPqK7Bh6b0MeTos1MIX/Bpm6b0W2+fZy6IEeOdpQh4wv5THDTl4n
 M9qgZlHvZjoSd2f9V/cTa6SabUIz9LI5vHIJSN7irKLdQfbP8Ip8KDEr5tKMSo90ZDPLY0+57
 xwvGVphEz//KF8EfPuqkrWpikHmva8ndX5TY9/RGE3Ych/Ubxhkr1xFg5jzbsUEARIFjbvaIo
 Z8mrMJml+sC6TBaqcdIXJGcaZOpL6pt4NmFkMwL6KTG9AXy230pfd6Y6yP/HhnsHVmjplwKWi
 oeRTLI+/vch7AXToR6Mfyio08Tkc+DnJxKuz09a5GwAWrrctAcEf/KG3UJrsNZAyNavoSPcme
 OBhuNfWyxPPvixfbfqL2CNX276APU0UosZVmET7GsZjpD2q45U3Ury4af/uY68187LguTL8Tl
 x4ELHiKS2Z2bVlYwzhmPUG+AJFSH8qp0ZNO3ORkeUOk93B+g1MK6VpkB3Mt9/RPyreyhe9tE5
 jwici+3h/fVgpRUI+2aau9NhATgb1f55MGnQXVc1vGUMVnVfx0AV90SKNnfxp9BHAw1qBmh/O
 tTlvrTS8xeirOvQqWQTn5b5jsteCVPaQF38rV0MsXYkWDclZ2GeovmOzBT+T/qCp4La4JVPAZ
 cbkSB9CGRFIxqlDcA8O7X4hc7SEydvHS3GSqGizN28aE+gAfljA/CGoHGvsUpqWzBfOBWsrWP
 oh5r0ktvjK7+OTXUP0a/R6F0O1TvK4dxbXPL1nEx+5MYycgyeeBuCvrBPTdx7+9KZXddnT5OX
 BnV3/AlK4Yv3HPTy7ZaetlDXZEFgqNTGEfcfR4+oZPFShFOFXUw4FF/Nw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 56739
Cc: 56739 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Hello,

I think we can fix this (both cases mentioned) similarly as in cl-letf:


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-WIP-Fix-symbol-macros-used-in-cl-psetf-Bug-56739.patch
Content-Transfer-Encoding: quoted-printable

=46rom 29ea21a751ab6e71b2fb34c781131e31fc7b950d Mon Sep 17 00:00:00 2001
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
Date: Wed, 3 Aug 2022 02:06:16 +0200
Subject: [PATCH] WIP: Fix symbol macros used in cl-psetf (Bug#56739)

=2D--
 lisp/emacs-lisp/cl-macs.el | 15 ++++++++++-----
 1 file changed, 10 insertions(+), 5 deletions(-)

diff --git a/lisp/emacs-lisp/cl-macs.el b/lisp/emacs-lisp/cl-macs.el
index 78d19db479..f3051752ba 100644
=2D-- a/lisp/emacs-lisp/cl-macs.el
+++ b/lisp/emacs-lisp/cl-macs.el
@@ -2653,12 +2653,17 @@ cl-psetf

 \(fn PLACE VAL PLACE VAL ...)"
   (declare (debug setf))
-  (let ((p args) (simple t) (vars nil))
+  (let ((p args) (simple t) (vars nil)
+        (smacros (alist-get :cl-symbol-macros macroexpand-all-environment=
)))
     (while p
-      (if (or (not (symbolp (car p))) (cl--expr-depends-p (nth 1 p) vars)=
)
-	  (setq simple nil))
-      (if (memq (car p) vars)
-	  (error "Destination duplicated in psetf: %s" (car p)))
+      (when (or (not (symbolp (car p)))
+                (assq (car p) smacros)
+                (and (symbolp (nth 1 p))
+                     (assq (nth 1 p) smacros))
+                (cl--expr-depends-p (nth 1 p) vars))
+	(setq simple nil))
+      (when (memq (car p) vars)
+	(error "Destination duplicated in psetf: %s" (car p)))
       (push (pop p) vars)
       (or p (error "Odd number of arguments to cl-psetf"))
       (pop p))
=2D-
2.30.2


--=-=-=
Content-Type: text/plain


But I'm not a fan of symbol macros any more: the concept sounds nice
first, but actually you only save one pair of parens when coding while
they introduce a special case that one always has too keep in mind for
macro expansions: any symbol might not just be a symbol.

I guess this is not the only place where they are not handled correctly.

Michael.

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#56739; Package emacs. Full text available.

Message received at 56739 <at> debbugs.gnu.org:


Received: (at 56739) by debbugs.gnu.org; 2 Aug 2022 23:59:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Aug 02 19:59:16 2022
Received: from localhost ([127.0.0.1]:45521 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oJ1nA-0000YK-9O
	for submit <at> debbugs.gnu.org; Tue, 02 Aug 2022 19:59:16 -0400
Received: from mout.web.de ([212.227.17.12]:46819)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1oJ1n9-0000Y8-4Q
 for 56739 <at> debbugs.gnu.org; Tue, 02 Aug 2022 19:59:15 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1659484744;
 bh=YlROXOIDc7l1vihH9i+Qk6WTn3/hz7hTr+vUlIZhXVY=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=GOTyxdr0YrqtwFnErxd5pv2dEFtuuGHEd/0gfhVl+JaYPUd3tP3utGquAGCh5TDYB
 75REzFEtHQM6CsGksM5hDhDVKHWeiC7l/y5NYMQtevirl2+PTVvEgof1z/xwi5KO69
 zxyBXyNwAnES+eCksqtKeTVVDLI0oF2FUXTNExzw=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.57.248.18]) by smtp.web.de (mrweb105
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MREzO-1o6z5Y1TrI-00NQRb; Wed, 03
 Aug 2022 01:59:04 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Wing Hei Chan <whmunkchan@HIDDEN>
Subject: Re: bug#56739: 29.0.50; `cl-psetq' and `cl-psetf' fail to recognize
 symbol macros
In-Reply-To: <OSZP286MB1260387EB0097C4D07840B54DA929@HIDDEN>
 (Wing Hei Chan's message of "Sun, 24 Jul 2022 20:12:10 +0800")
References: <OSZP286MB1260387EB0097C4D07840B54DA929@HIDDEN>
Date: Wed, 03 Aug 2022 01:59:01 +0200
Message-ID: <8735eeyz7e.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:SiTKVgkohEpva9SppQG7GtdtVj00RGqQNoCUJ+MwX+se5CF2C5O
 2OC6pgnZ+9klEVW4l8pgvxaz9z+oeZnSQvEFSM+D7OZy4wz6H04dQIYZ+TMmA6mgjBTo/E5
 2b1MI+CxG2jV1lYuwutaFMssqbFYK59n3RG3+NRhD2DHEezalgp8TVqIP9M5mK0jBsY15es
 2hGz6GmsMDYtBI0vGrxog==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:uX7CMl+2UoY=:mOxudEprPkapxESWxqpSlf
 IpQ2h8X4g1R+2wncCapTmTZwPWDYNBfrYVjLsD+Qz7pcH1Qt8+2IX5VKFU/R7L1zEVUoXPR02
 yyjYjQxH/orrh1F6WnP0+68qLejMa1z8PU4btat0d6dCcTtGlbVoYcDqQZUln33NrRqMyr/rK
 xB8NCqlviFjOYJfNFOeci1RNvDxfXtVH6hXbe6V8xTkjQpzNXtSSl8FpFaxLD/67R88Grd6f6
 V+sntLF51QYUX716OxHzCL37LVCpJOFELR/6WpAM4HpydWtvjYxHXGNrEngVoPfgggFUdm38C
 2sIxegXMnDLK+1fQTzMoTTl//EnvQLGqq9uAmD2PuxP6kQWKtsrbI0cbWzcLXDqHS3yytgVj3
 C4uYNiwBR3DGA4IS0v8hD9TJh/ExRS55Ax5q1p8OJuwAO44dyYlZX29In9K9SL7S7N+sg7G/s
 v5t2Vmrr7j3/iVwAGNb6RJaUVsMbdpko8y8vyTewDCH6LDc7EwplflAYhqPh4HSbm8oF+3VmG
 lu6ERaKGhmGa1hVG/C4/+Qu68YSXBTtw6k/zqNeJ3oK8Bdthra4imy4AEOt5MBi6rh4Td7aL0
 0VpyadivDG1h+qchIYX9FCxKM7s2duIyGXPQ6gu6uye/8K3XxdMow9pmryqVgl7kzKZuQnv5q
 eApZuDjOIESjfRLZ0RzPLMNSH6Jqw8zuoIZHJqYjJdSl4+wZl3iI6Gi8Sq7CMPI4xaHL1msf4
 W4YxQrI5Z9Ciyf5Ketk2szbIEOPiRafNZF8FQyqX7zDjB0RlHElkzfOcKEB63v+H0Dzhdmsup
 sC1sz7rk4zVTEYQzlz1XWEnvkE+e72Z9d8he5malNf9r1kugbbvO4Y499LcRKYUUhHfp4BHen
 +omt6ybjxHg3W8Tuiz0SVHdmdipziPI3sQn9045pcRGOX5at5CHE+ndDE4Cp2c6Ak8F/LT3jY
 f7yrtHbw0PZOg24DACRI3ISUC6rQqA/KM+oz/DAQoSMR/yDQAxLr2e8oKYxr2Lnx86+mhAfCn
 JCdIhxz1t8oN3gcE/g64knNjoxKsnt1y0zddcbEBtXbzukMoy1LrG0O6CpmHTAtiAsRvjHueZ
 fklEztTELIuFdTtK+PNkkR37IyPwnqxf6+Cn0vom9eZvq9XZ+SDQFUrCQ==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 56739
Cc: 56739 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Wing Hei Chan <whmunkchan@HIDDEN> writes:

> The following form produces (2 2) due to the failure of detecting
> dependencies involving symbol macros.
>
> (cl-symbol-macrolet ((c a))
>   (let ((a 1) (b 2))
>     (cl-psetq a b
>               b c)
>     (list a b)))

There is a second case that also fails: a symbol macro at a PLACE
position:

(cl-symbol-macrolet ((c a))
  (let ((a 1))
    (cl-psetf c 2
              b a)
    (list a b)))

==> (2 2)  ;should be (2 1)

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#56739; Package emacs. Full text available.

Message received at 56739 <at> debbugs.gnu.org:


Received: (at 56739) by debbugs.gnu.org; 2 Aug 2022 02:41:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Aug 01 22:41:52 2022
Received: from localhost ([127.0.0.1]:41951 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oIhqx-00086E-Po
	for submit <at> debbugs.gnu.org; Mon, 01 Aug 2022 22:41:52 -0400
Received: from mout.web.de ([212.227.17.12]:40607)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1oIhqv-00085w-B8
 for 56739 <at> debbugs.gnu.org; Mon, 01 Aug 2022 22:41:49 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1659408099;
 bh=NIFq+sxub0Dr7ojUUOtzlBnvnVsyOHPOvEXgVGCNeBo=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=B304zySDiWXuUODW5njEgZ9nkU/TGygQE0wMACQaoHfMggoWR+Yjq9h9iF9N7ncRo
 +dKBvceLfbzPzxKcsS89mHAlIeuUHqv+SHFB4MCkUXkPvFXtrZEhm3wmWPn3/wdsnc
 PEeRvKxk4s0Con38qxSeGxRNC0ov7kqWp4kgX4ME=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.57.248.18]) by smtp.web.de (mrweb105
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MJWoU-1nyy2l0ihk-00K7dq; Tue, 02
 Aug 2022 04:41:39 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Wing Hei Chan <whmunkchan@HIDDEN>
Subject: Re: bug#56739: 29.0.50; `cl-psetq' and `cl-psetf' fail to recognize
 symbol macros
In-Reply-To: <OSZP286MB1260387EB0097C4D07840B54DA929@HIDDEN>
 (Wing Hei Chan's message of "Sun, 24 Jul 2022 20:12:10 +0800")
References: <OSZP286MB1260387EB0097C4D07840B54DA929@HIDDEN>
Date: Tue, 02 Aug 2022 04:41:38 +0200
Message-ID: <87zggntli5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:HJhvizpdkYXm6bMWvqUhmiWh5zxWaYL5VYKngzT4nclLsgIKt/W
 EOLeF+H6Q147pLHHJcHHJTaSIiBrMb0+6fGjzjeqYInxeMDjROZbnN82iEetXM3xRRiuCyT
 /xFXAip7WcNWvvwSx5rGJ70FpTRnJwivaZUppIc9vPdtp9VtD9pDkfc3Vt62kRb8AfrAgMx
 nCws5MPFA93QCgyPDPWEg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:OVUACjW9MjA=:ICc1zWxh9CfAud733Ss+sw
 M+3xiaTsvj5O1UyuvNku5CBVCi+jcWC/UNQVZ30y94fU9bqH68+Re5dcW2KI2zPBLkiqTvfAL
 OMbUDWezqeX2vJX2XdV/vnXrzTaCH8gGGweKsJh0EeEM/NLB5CCCdeQbRzgKeD/+dpZz4DwzA
 sWTxO7K0XnKpjhtkf+Bimq0auhv5tTDwYUjwvY0kwbfWW8/mPsa/zOLJYpc5poWShF769Eo0D
 crDXfxFskIFVH9DDIDlwLn9UAdkob3VFGgx9KBmMzp6Pngehhh0RCOhYkLI78FserqiBpooOb
 +GzhfncqHWLZpGQfR3Ea0KMLrds32pyXax3M3pgojsTy0rG/xdA//1KpMuCVyboONJpnn0uph
 gQYlHL6oNg5xvJlJcRUDlDkGEnrz70VkkzOYyS7bgzXFqQe9dyZX7SjiWVtgvszhrjQyF+39A
 ZJxppGK3A1lvgFghK+BduuaWu1x14Lurxw89jZSz7R3b7DHKJDNDm+T0XmBHp0POdBWn+FZ6l
 x3g1rFBA3BATFODsV3MX1u1Czk2XGb/FwcyT5yUL417xVQjYLBsYFjydp++IpURDz7B3VpIOA
 5OjyrzfABNKuSBtkOLqPWCY4MdKdZFNL2aPKt8efR7fjL27iw5n50AMZw2ppGlwUJBxvy8QQI
 0wxEU5TM6BivDQXyhrsn/k8lFgOvu0yiTrZPDZPkXLsYN3SbbyP+nWCXTv//GwelK69D1q2vp
 7eguETnUkq6WjN23Rwl+lPYb+d2BZX6Ug3ohrlhYgK7sIy3eL4qpIy6OpNND9J4pyrKr71Ei/
 0pS7sFKdTNnk2Kels1cLa8OPcxa5OGtsGU4mDXfDl4WDuQZX+IRaxTwZSu67gYLAM9Wd2UdU5
 AVomKojhbM8pscmGUPcpHNRVRhW0LX4Wxt0BwEEAITihQXORbtZ4r9BMJiXF7ZVM6L2v4Xude
 +MpKpu5HUIKA/I+vFNsr4+EWigclaLpbJBE6QEnmT4CPmGA5tB6r/mnlB6dEvt54llQHnT9a/
 K8NCeAmzOrFUzwV3+YpVOCtljrk++u96Icak8gnKk88Iy2uPLe9oDTozyLXa5zslKXCdIizRf
 LHmrThfAvnpTTxFHxaOhPo/EnWNjzUTP3qV1F95lYXSmVdvJx41bLLPkA==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 56739
Cc: 56739 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Wing Hei Chan <whmunkchan@HIDDEN> writes:

> The following form produces (2 2) due to the failure of detecting
> dependencies involving symbol macros.
>
> (cl-symbol-macrolet ((c a))
>   (let ((a 1) (b 2))
>     (cl-psetq a b
>               b c)
>     (list a b)))

Dunno how a good fix would look like - but it is easy to follow why this
error happens: `cl-psetf' analyses the expressions (each second
argument) for whether they are "simple" (independent of the variables):

(if (or (not (symbolp (car p))) (cl--expr-depends-p (nth 1 p) vars))
  (setq simple nil))

but the symbol macro is not yet expanded when this is done, and the
expression `c` passes the test - which is wrong.

Maybe that test should just check for symbol macros in addition?

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#56739; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Jul 2022 12:33:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 24 08:33:47 2022
Received: from localhost ([127.0.0.1]:47047 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oFanr-0003Vl-GS
	for submit <at> debbugs.gnu.org; Sun, 24 Jul 2022 08:33:47 -0400
Received: from lists.gnu.org ([209.51.188.17]:39520)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whmunkchan@HIDDEN>) id 1oFaYJ-00031k-Qv
 for submit <at> debbugs.gnu.org; Sun, 24 Jul 2022 08:17:44 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:55794)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <whmunkchan@HIDDEN>)
 id 1oFaYJ-0003fs-Jq
 for bug-gnu-emacs@HIDDEN; Sun, 24 Jul 2022 08:17:43 -0400
Received: from mail-os0jpn01olkn20824.outbound.protection.outlook.com
 ([2a01:111:f403:700c::824]:30486
 helo=JPN01-OS0-obe.outbound.protection.outlook.com)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <whmunkchan@HIDDEN>)
 id 1oFaYG-0007LX-Ez
 for bug-gnu-emacs@HIDDEN; Sun, 24 Jul 2022 08:17:42 -0400
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=Tt5Li4+QPSjIK4q8Pd/a1ESrd/RVownNJlBTR/LlRwYQUKZqoNYAnc98mvzmVDuNi9/3pva59J4UAu2Pls2hm0y1zSIAVPeqfEVCeAtkwRzjrrk/oQSs8CqztGJcgL07RbmwbsgKtY+p+PJYeYk7NQDged3eIQ20DaoNVBkUkb68lMQIjaSncOjVQBBhw+pw0Iz1JJx1ASglwBj9XIvKlx+tPOUonSmogVMZz7T11GjDY+apCTFG3slsdlRVGoDgvQubvL/rMXTi5w4EX6VFFcIoJ/uKroZJxQk361Rl/ESK5lwxQVJiBAFg2BWFd0GJNsMgZwWS5zAoA0asyaEAhA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-AntiSpam-MessageData-ChunkCount:X-MS-Exchange-AntiSpam-MessageData-0:X-MS-Exchange-AntiSpam-MessageData-1;
 bh=iFHWnTNRMW/jQOLFBl6S/+ILzO12Ty6iGfFwdBdRis4=;
 b=clgqN+6RZ8zsas0XL4pPu4w9zVkscNKtUTOKZSNklcEA4ATbYvMjEfgQ3ldKyfs0lIOkTRPqXwVMBNr8RKexJBnGVP6WUTkwFE1BwTpBI6cY3W7P8lgZO6qKQQB2n/9PTX+NltL4ieWSyNWvpJdzUCUiE74e35fEzHbTF4BGlOUg2LhxX5Hww3YKtHrcl7LHIAdFm92H9c0isbbFXusPC544qx3ppviFggpcnQPINUBPhDxdDkY0x4Mpvyycss1c7phOaiKZ2grt2o+kHN6FiptN3IpGv2xbgGGtRI7jobyXVqxjVWWIJuFMe3jMAWqNJvUMy57TN+Yel9UH6dkruA==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=none; dmarc=none;
 dkim=none; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=iFHWnTNRMW/jQOLFBl6S/+ILzO12Ty6iGfFwdBdRis4=;
 b=L+YL1nEl2x+rfHmmlQ2f/LgZ0qQiXzTVxqraNn7ZYS/usojySuVLUyeeFN8ifbet9csElFVAV8EUbfmnkgTKpCj4F2hSV62fz/Wojq0NTsRErkWRuK6x3/U2k8WS7pSp1AhQTt8BiEnw3Ecfpxv/VQLedP0xnZBiWVp0U3SoMMa9NFEacnI36scPJKc/m1lXDeRpBAaMbXSRaknsMzv1mwECcxXvTctuD64c2XXCb4Q2llHjWtClv5j5E1AjUtYIvApztiZrCHJ3fnu4i0Oc8lSuPH6GCoQ4pM+gdFEzchd353gUyUEG3BdLZ5nOba5uG7S8Rz+E4VMS8nIw2zxobw==
Received: from OSZP286MB1260.JPNP286.PROD.OUTLOOK.COM (2603:1096:604:138::9)
 by OS0P286MB0532.JPNP286.PROD.OUTLOOK.COM (2603:1096:604:cd::14) with
 Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.5458.18; Sun, 24 Jul
 2022 12:12:30 +0000
Received: from OSZP286MB1260.JPNP286.PROD.OUTLOOK.COM
 ([fe80::15ce:437f:f4e5:f9ed]) by OSZP286MB1260.JPNP286.PROD.OUTLOOK.COM
 ([fe80::15ce:437f:f4e5:f9ed%5]) with mapi id 15.20.5458.023; Sun, 24 Jul 2022
 12:12:30 +0000
Message-ID: <OSZP286MB1260387EB0097C4D07840B54DA929@HIDDEN>
Date: Sun, 24 Jul 2022 20:12:10 +0800
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:91.0) Gecko/20100101
 Thunderbird/91.11.0
To: bug-gnu-emacs@HIDDEN
Subject: 29.0.50; `cl-psetq' and `cl-psetf' fail to recognize symbol macros
Content-Language: en-US
From: Wing Hei Chan <whmunkchan@HIDDEN>
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-TMN: [IKSKLRaQfU2OqH9nFbesBsEzZdLJCogJ]
X-ClientProxiedBy: PS2PR01CA0062.apcprd01.prod.exchangelabs.com
 (2603:1096:300:57::26) To OSZP286MB1260.JPNP286.PROD.OUTLOOK.COM
 (2603:1096:604:138::9)
X-Microsoft-Original-Message-ID: <c886faad-c1a9-e6f1-2880-11a8e18dc40b@HIDDEN>
MIME-Version: 1.0
X-MS-Exchange-MessageSentRepresentingType: 1
X-MS-PublicTrafficType: Email
X-MS-Office365-Filtering-Correlation-Id: e4d3e684-3cce-48e2-2236-08da6d6dc7f1
X-MS-TrafficTypeDiagnostic: OS0P286MB0532:EE_
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: D8C544prX4mmAtoVUnbel7Zjrt0cWWl/soKwJxBHJCXOph36phHrDNdJCyHR/1OxLnlhrGJ6jwEQswKcUHbaSfB/U0AG1/ljFUEQEDZEP+lJAES/p78cW5dwb70EiqSakeCgvAtFcm6I5Ku3tRhGHS0BbfzloMrDXpOTmCsFGSw1rby+9HiFt3Lfw2TBpqfJdDBlRpwoNvRPjuV64uKUIwRAuajlqEJekLutDugdoGKiXk189llthZLg1D94cJA23ccXKUhipmD4lXtGO11UGTOcMQMuAdELQcQHSrzsnTXASeaIcy0vczawNDmHaVHX+aOXSrvr+8FOeg5bEMVrAwMY4gcFouQ5sOqV1BqWM8dfdkc1ngyW72FARM2PaLeyOZM4vFNdkpkaEw4xCpfZ/HIO6T7rWGo0pgLwvfhAdLoXs0h7M3vEofAVVKMdgj2mfAedWfdInwFcQCVRWxYIC4za206pkpb/bcDW1DpSsZR5Kw5KJ6hRJFBZeeo4n0OX5oykUWbFfEwgvZgD5goUhIN5l5PxZx7vQLBXIiMC86OmcHlSoKPocDzX8oaKkJ/OMysd+eXoRHndtyohSIJ31f+6jE/Chu3ZlX/GwhhVW36igSLqAPd3njqHDB9w7nmhM04xTgjUibIJZlN29U2dmg==
X-MS-Exchange-AntiSpam-MessageData-ChunkCount: 1
X-MS-Exchange-AntiSpam-MessageData-0: =?utf-8?B?RHg0TXZUNkpaWXpZa1VySldIcjB1S25YR2g0NXNhdjFzQmpKeE9weHYvS2tv?=
 =?utf-8?B?UE5wamZlRmUxa3NBZEpEZjBJYWxGLzNYWDhhRmxUcXdSelJPU0wrSEtIUVk2?=
 =?utf-8?B?ckxlMHlTeGJFbzhXa2dxdEM4aStJN1NRRUNNc2JnT2FHODQrcm8yT01ud3Fl?=
 =?utf-8?B?a0M3T3dzbHZicldhSlZsVzVpNzF6VTVhVjF0RmR6Zk5FM2dOajdKSTltWm9l?=
 =?utf-8?B?SVNZMWxpMFZCaTNaZDc1WWwveDFmYWlYWmJnakdLVVhtU2U4YUFzZzRyOVg1?=
 =?utf-8?B?V1VNckoyYmVXclJ2QzlxQXVKZ3FkSDhwYUw1YjJycjI4Y3lVZXg3WnpqaHBK?=
 =?utf-8?B?STNEeEpFNVRmUnlxMEJudmczVHdYRzJQcHd4eUQ5aTBOQ3YvUkFJZm0xSWh2?=
 =?utf-8?B?NEdTNEhnRnlYbFlUQUY2SnlleXlGRTEzVXVTakNYd2VRM0dmWEgyRERrRG5s?=
 =?utf-8?B?NTQ1RUErbEthYXBxRXhzdzhJMk0xWFd5NmJ3YTc3VUZGQ3RtUTh5UzBDWnBI?=
 =?utf-8?B?RkpWTSs1MkFRTERVRE16UzVwVWRpcjgxQ3libXFFNGp4TGJua1ZBMjZSTWN1?=
 =?utf-8?B?T20zekV0VlRnQjI1eFpZV2xVNW1KT3Vmb05NaUVyVVFhY2UwOVNoQkdjL2F0?=
 =?utf-8?B?NHd1Z3dMSXRrYnJlNmhpTFQ4dTFhdStma1Bkd2MwZHlUc2cwYVQrQlN3d25W?=
 =?utf-8?B?dTBFcm9tY1Y2cVVqYzBFbnZSdXgzdGxiUnJvV1lwOUdxQmxWYkNJUlRVaEpj?=
 =?utf-8?B?czZMdWxHYmM0QU1qdVR4blY1RHdHUUFBdDlkRzVFSmthbU11b0ZpYUZwTEFB?=
 =?utf-8?B?bmZqZWpsV3ZsZFZ6NUdwcHc3MjdZMVhFUHhVT01xbHU2UjNmbU1zTitSVUNK?=
 =?utf-8?B?cXpDQzU4bkFhWHNHUHVOaXNHc1BJRWlodjk4VDg2VXAyNWpxdERwK1YrYzRy?=
 =?utf-8?B?QUM2aytCMVFUWDlMclR3TWNQbTlYdVQyYytvd0tCS0ZvQUhLd0hHR2plODdR?=
 =?utf-8?B?K3ZCbHlSTzZwT3pDQUE4REtwVVpyRUpoeHpnZGdxSWhHcXdwdlE0YXdJWWFC?=
 =?utf-8?B?V2IyZmY4MlRiZUFqaVEzdk45eFVCZWhWbzUrY3FnbFhXMStPZWRBRW0wR3RK?=
 =?utf-8?B?VXVFVGx3QkRWVkxBQk40UThEYW9vVnJmN2MvRERzcmp5bWlVMnZUQzlVYkpt?=
 =?utf-8?B?ejE5US9jbHVHZ0lKcTVDVVpaS28rYU41VStsMVFSV1JwdTNmV3hLSW5kWEg4?=
 =?utf-8?B?TkdteFdaUTNXemNNbWFiTWRuV3RtVUxNUGdGR0V5SlZGZjJSOUJvNHJrUTFE?=
 =?utf-8?B?VnA2WEVaTnBSL011N2V2TU4raHY0Y29IbStPQnpMeHl6cks5SER6YXlLNlg2?=
 =?utf-8?B?YlhPeXNXUnVRNUVxN3k4d0RrQnFPMVV4V0lnTXIyQk4vVXRaSm9vOEZsNjd6?=
 =?utf-8?B?RFIrRlFBaFgwWFdhRHhQQ1krMjg0V2RlbGM3SGdUdlNZMXZUazN0V0Q2d2s1?=
 =?utf-8?B?dk5TME9WM3J0U3E3eTJXZlNUdkxaTm1ERTB6dzlWSGE3aitQaWhhUm1uVVlM?=
 =?utf-8?B?bW9XZERhNkxvQ1hESWlLSEVITEg5WVR6SnNLZFVJamdCR1Y0WUw4OWNoelE3?=
 =?utf-8?B?TVRwRFl0UWZKUUNJcyttbFJ2TWhPTDVRMENUdHpZeDFDVWNIVG5RNGdrV3Jz?=
 =?utf-8?B?ZWNSWnZOUjl2MHlmT1dDOHdJQTU0d2hDaUswYnZmQTd6d2FNOWxHNmNRPT0=?=
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: e4d3e684-3cce-48e2-2236-08da6d6dc7f1
X-MS-Exchange-CrossTenant-AuthSource: OSZP286MB1260.JPNP286.PROD.OUTLOOK.COM
X-MS-Exchange-CrossTenant-AuthAs: Internal
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 24 Jul 2022 12:12:30.2177 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: OS0P286MB0532
Received-SPF: pass client-ip=2a01:111:f403:700c::824;
 envelope-from=whmunkchan@HIDDEN;
 helo=JPN01-OS0-obe.outbound.protection.outlook.com
X-Spam_score_int: 2
X-Spam_score: 0.2
X-Spam_bar: /
X-Spam_report: (0.2 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1, DKIM_VALID=-0.1,
 DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FORGED_MUA_MOZILLA=2.309,
 FREEMAIL_FROM=0.001, SPF_HELO_PASS=-0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 1.8 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: The following form produces (2 2) due to the failure of
 detecting
 dependencies involving symbol macros. (cl-symbol-macrolet ((c a)) (let ((a
 1) (b 2)) (cl-psetq a b b c) (list a b))) It should have behaved the same
 as the following form without symbol macros, that is, producing (2 1). 
 Content analysis details:   (1.8 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
 medium trust [209.51.188.17 listed in list.dnswl.org]
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (whmunkchan[at]outlook.com)
 1.0 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 1.6 FORGED_MUA_MOZILLA     Forged mail pretending to be from Mozilla
 1.5 SPOOFED_FREEMAIL       No description available.
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Sun, 24 Jul 2022 08:33:39 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

The following form produces (2 2) due to the failure of detecting
dependencies involving symbol macros.

(cl-symbol-macrolet ((c a))
   (let ((a 1) (b 2))
     (cl-psetq a b
               b c)
     (list a b)))

It should have behaved the same as the following form without symbol
macros, that is, producing (2 1).

(let ((a 1) (b 2))
   (cl-psetq a b
             b a)
   (list a b))




Acknowledgement sent to Wing Hei Chan <whmunkchan@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#56739; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 5 Sep 2022 19:30:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.